function [r,vhat] = ECM1RC(th,data,OCVf,params0)

% Init
v = data.v;
i = data.i;
dt = diff(data.t);

n = numel(i);    % Insignal i = [i_1, ..., i_n]'% ; 
vc = zeros(n,1); % Initialvillkor vc(1) = 0
z = zeros(n,1);
vhat = zeros(n,1); 

% Set parameters
x = ones(5,1);
x(1:numel(th)) = th;
params = x.*params0;
Ri = params(1);
C  = params(2);
R  = params(3);
z(1) = params(4);
Q = params(5);

% Simulate model
for k = 1:n-1
    z(k+1) = z(k) + dt(k) * i(k)/Q;
    vhat(k) =  vc(k) + OCVf(z(k)) + Ri*i(k);
    vc(k+1) = vc(k)*(1-dt(k)/(R*C)) + 1/C*i(k)*dt(k);
end
vhat(n) =  vc(n) + OCVf(z(n)) + Ri*i(n);

% Evaluate error
r = mean((v-vhat).^2); 
end