clc;
close all;
clear all;

battery_data = readtable('A1-008-OCV-25-20120905.xlsx', 'Sheet', 'Channel_1-005');

Current = battery_data.Current_A_';
Voltage = battery_data.Voltage_V_';
Time = battery_data.Test_Time_s_';
Step_index = battery_data.Step_Index';

idx_dis = find(Step_index == 5);
idx_chg = find(Step_index == 7);

idx = find(Step_index>= 4);
tmp = cumtrapz(Time/3600,Current);
tmpdis = cumtrapz(Time(idx_dis)/3600,-Current(idx_dis));
tmpchg = cumtrapz(Time(idx_chg)/3600,Current(idx_chg));
figure 
plot(Time(idx_dis),Current(idx_dis))
figure
plot(Time,Voltage)
figure
plot(Time, tmp)

%%
Qdis = abs(tmp(idx_dis(end)) - tmp(idx_dis(1)));
Qchg = abs(tmp(idx_chg(end)) - tmp(idx_chg(1)));
Q = (Qchg + Qdis)/2
Vmax= max(Voltage)
Vmin = min(Voltage)
SOCdis = (Q-tmpdis)/Q;

SOC_grid = 0:0.01:1;
Vdis_grid = interp1(SOCdis,Vdis,SOC_grid);
Vdis_grid(end) = 3.8;
Vdis_grid(1) = Vmin;

SOCchg = abs(tmpchg)/Q;
Vchg = Voltage(idx_chg);

Vchg_grid = interp1(SOCchg,Vchg,SOC_grid);
Vchg_grid(1) = Vmin;
Vchg_grid(end) = 3.8;
OCV = (Vchg_grid+Vdis_grid)/2;

figure(1);clf
plot(SOC_grid*100,OCV', 'LineWidth',2 );
title('SOC vs OCV')
xlabel('SOC [%]')
ylabel('Voltage [V]')
legend('SOC vs OCV')
 
OCV(101) = 3.65;  % Set OCV at index 101


OCVf = @(z) interp1(SOC_grid,OCV,z)
SOCf = @(v) interp1(OCV,SOC_grid,v)
