clear all
clc
addpath('EKF')
HERE = 1;

data = load('A123_dynamic_data_sample_2.mat');
load('OCV_SOC_data.mat') 

figure;
plot(data.Current)
figure;
plot(data.Voltage)

%%
% Choose data interval to only include the first discharge cycle
startidx = HERE;
endidx = HERE;

Time = data.Time(startidx:endidx);
Voltage = data.Voltage(startidx:endidx);
Current = data.Current(startidx:endidx);

% See profile for chosen range
figure;
plot(Current)
figure;
plot(Voltage)
%%
close all;
% Define nonlinear model
mod.nx = 1; % Number of states
mod.nw = 1; % Dimension of process noise w
Q = 1.0865*3600;    % Capacity 
R = 0.28;           % Sum of estimated R + Ri

% f function
mod.f = @(x,u,w) HERE;

% h function
mod.h = @(x,u) HERE; 

% F matrix
mod.fx = @(x,u,w) HERE ;    % Jacobian of df/dx 

% G matrix
mod.fw = @(x,u,w) HERE;     % Jacobian of df/dw

% Define OCVf and SOCf functions
OCVf = @(z) HERE;
SOCf = @(v) HERE;

% H matrix
SOC = HERE;                 % Create SOC vector   
dOCVdSOC = gradient(OCVf(SOC(:)), SOC); % Numerical derivative 
dOCVdz = @(z) interp1(SOC,dOCVdSOC,z);
mod.hx = @(x,u) HERE;       % Jacobian of dh/dx = H

% Initial conditions
x0 = HERE;                  % Inital guess of SOC. For example SOCf(Voltage(1))
P0 = HERE;                  % Initial uncertainty of init SOC

% Covariance matrices
mod.R = 0.2^2;              % Noise variance in measurement (V)
mod.Q = (3)^2;              % Noise varinace in model (SOC) 
% NOTE: the standard deviation for Q matrix is set for if SOC is in [%].
% If not, scale it down by 100;

% Input data
u = HERE;

data.u = u;
data.y = Voltage; 

% True SOC to comapre results with
trueSOC = HERE;

% Perform EKF
[xhat,yhat,P]=EKF(mod, data, x0, P0);

%% PLOTS 

HERE; % Optional: Plot state estimate xhat


HERE; % Optional: Plot model prediction yhat


% Initialize vectors for confidence bounds
lower_bound = zeros(size(xhat));
upper_bound = zeros(size(xhat));

for i = 1:length(P)
    % Extract P{i} and compute sigma
    HERE;

    % Compute the upper and lower bounds
    lower_bound(i) = HERE;
    upper_bound(i) = HERE;
end

HERE; % Plot 3sigma coinfidence interval
