# TSFS19: Battery Systems

<!--**Lecturer**: Mattias Krysander ([mattias.krysander@liu.se](mailto:mattias.krysander@liu.se))-->

This repository includes lecture notes, material for exercise sessions, computer labs, links to reading material, and other course material. Information here will be added during the course, and you can always get the latest version of course material here. 

The course consists of lectures, exercise sessions, computer labs, and a written examination.


## Table of Contents

- [Curriculum](https://studieinfo.liu.se/en/kurs/TSFS19/vt-2025)
- [Schedule](https://cloud.timeedit.net/liu/web/schema/riqmZQY76ZXZ27Qy3Y7Q14c06bZ596Q6m0c0053Q9Yo5Qga5pZZ7Qq6Qo.html)
- [Lecture Plan](#lecture-plan)
- [Exercise Sessions](#exercise-sessions)
- [Computer Labs](#computer-labs)
- [Exam](#exam)
- [Reading Material](#reading-material)
- [Public Battery Data](#public-battery-data)

## Lecture Plan
The table below shows the lecture plan for the course. The lecture slides and notes will be added to the [Lectures](Lectures) folder during the course. The column "Prep for" indicates which exercise sessions and computer labs you should be prepared for after attending the corresponding lecture. The table also includes recommended reading materials, which are not mandatory but can enhance your understanding of the course content. EE stands for the book "Electrochemical Engineering" by Tomas Fuller and John Harb. Reading material is provided in the [Lisam](https://liuonline.sharepoint.com/:f:/r/sites/Lisam_TSFS19_2025VT_59/CourseDocuments/Reading%20Material?csf=1&web=1&e=ff480K). 


| Lec | Date | Topic                                    | Prep for | Reading Instructions |
|-----|----|-------------------------------------------|---------|---------------|
| 1 |1/4|    Battery introduction [Slides](Lectures/Lec1.pdf) [Notes](Lectures/Notes1.pdf) |  | EE, 1, 2-2.4 
| 2 |2/4|    Battery properties [Slides](Lectures/Lec2.pdf) <!--[Notes](Lectures/Notes2.pdf)-->   | Ex 1,2 | EE, 7 (not p 161) [Visualizations](https://www.chemtube3d.com/category/inorganic-chemistry/lithium-ion-batteries/)
| 3  |7/4|  Battery modeling [Slides](Lectures/Lec3.pdf) [Notes](Lectures/Notes3.pdf) | Ex 3 | [BMS I.2](http://mocha-java.uccs.edu/ECE5710/ECE5710-Notes02.pdf)
| 4  |9/4| Battery modeling, [Slides](Lectures/Lec3.pdf)                         | Ex 4, Lab 1 | [BMS I.2](http://mocha-java.uccs.edu/ECE5710/ECE5710-Notes02.pdf)
| 5   |14/4| State of charge estimation [Slides](Lectures/Lec5.pdf) [Notes](Lectures/Notes5.pdf)               | Ex 5, Lab 2 | [BMS II.3](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes03.pdf) (3.1-3.3, 3.8, 3.12)
| 6   |23/4| Battery pack design <!--[Slides](Lectures/Lec6.pdf) [Notes](Lectures/Notes6.pdf)-->                    | Ex 6,  | EE 8, [BMS II.1](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes01.pdf)
| 7   |30/4| Simulation of cells and battery packs <!--[Slides](Lectures/Lec7/Lec7_Slides.pdf)-->    | Ex 7, Lab 3 | EE 12, [BMS II.2](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes02.pdf)
| 8   |6/5| Electric vehicle application <!--[Slides](Lectures/Lec8/Lec8_Slides.pdf)-->  |Lab 4 |   
| 9   |12/5| Cell balancing <!--[Slides](Lectures/Lec9/Lec9_Slides.pdf)-->        | Ex 9 | [BMS II.5](http://mocha-java.uccs.edu/ECE5720/ECE5720-Notes05.pdf) <!--[BMS II.4.1-4.3](Reading_material/04-Battery-Health-Estimation.pdf)-->
| 10  |20/5| Exam preparation. Possible guest lecture. | Ex 10  | [Exam241218](Exams/exam241218.pdf) <!--[BMS II.6](Reading_material/06-Voltage-Based-Power-Limit-Estimation.pdf)-->

## Exercise Sessions

The exercises are provided in the [Exercises](Exercises) folder. **A computer with a Matlab installation is required to solve many exercises.**

The table below shows the exercises for each session. The exercises in **bold are the recommended exercises** to solve during the sessions. The other exercises are supplementary. The exercises are coarsely categorized in difficulty level: Easy, Standard, and Extra. Introductionary exercises are marked easy, standard exercises are for students aiming for a passing grade, and extra tasks are recommended for students aiming for a higher grade or to deepen their understanding of the subject.

|Ex |Date  | Recommended Tasks | All Tasks           
|---|----- |-------------------|-------------------------|
| 1 | 2/4  | 1.1, 1.2, 1.3, 1.6, 1.7, 1.9 | 1.1-1.12  |
| 2 | 4/4  | 2.1, 2.2, 2.3, 2.5, 2.6, 2.7 | 2.1-2.10  |
| 3 | 8/4  | 3.1, 3.2, 3.3, 3.4 | 3.1-3.7 | 
| 4 | 9/4  | 3.5, 3.6 | 3.1-3.7 |
| 5 | 15/4 | 4.1, 4.2, 4.4, 4.5 |4.1 - 4.6 |
| 6 | 23/4 | 5.1, 5.2, 5.3, 5.4, 5.5 | 5.1-5.7 |  
| 7 | 30/4 | Not used
| 8 | 7/5  | TBD            | 6.1-6.6 | 
| 9 | 13/5 | TBD            | 7.1-7.6 |  
|10 | 21/5 | Exam preparation |  |

<!--
| Lesson   | Easy Tasks        | Standard Tasks           | Extra Tasks        |
|----------|------------------|-------------------------|--------------------|
| Lesson 1 | **1.1**, **1.2**, **1.3**, **1.6** | 1.4, 1.5, **1.7**, **1.9**, 1.10 | 1.8, 1.11, 1.12  |
| Lesson 2 | **2.1**, **2.2**, **2.3** | 2.4 (D), **2.5**, **2.6**, **2.7 (D)** | 2.8, 2.9, 2.10 (D) |
| Lesson 3 | **3.1**, **3.2**, 3.3, 3.6 | 3.4, 3.5, 3.7 |  |
| Lesson 4 | **4.1**, **4.2**, 4.3, **4.4** | **4.5**, 4.6 |  |
| Lesson 5 | **5.1**, **5.2**, 5.4, 5.5, 5.6 | 5.3 | 5.7 |
| Lesson 6 | **6.1**, 6.2, **6.3**, 6.4 | 6.5, 6.6 |  |
| Lesson 7 | 7.1, 7.2, 7.3, 7.4 | 7.5, 7.6 |  |
| Lesson 8 |  |  |  |
| Lesson 9 |  |  |  |
-->

## Computer Labs

The computer labs are provided in the [Labs](Labs) folder. The first two labs are designed for **Python**, while the final lab is designed for **Matlab**. The labs are done in pairs (groups of two students). Please register the lab groups at [Lisam](https://signup.app.cloud.it.liu.se/Courses/TSFS19_2025VT_59/admin/activities/15156?occasionId=125025) before Thursday 10/4 16:00.

Lab sessions are scheduled in rooms without computers, so you should bring your laptop and collaborate with your lab partner. The labs are assessed during the sessions by demonstrating and discussing your work with the lab assistant.

Each lab includes preparation tasks that should be completed before the session starts. It is also possible to complete the labs at home and only attend the scheduled session for the examination. If you fall behind, you can catch up on previous labs during the lab sessions.

Make sure that you have the required software installed on your laptop before the lab sessions. Some basic instructions for Python are provided [here](Labs/README.md). For more information about the Python environment and workflow, more detailed instructions are provided [here](https://gitlab.liu.se/vehsys/tsfs12/-/blob/master/Lecture_notes/computer_tools_introduction.pdf).

The lab PM for the course is available [**here**](Labs/LabPM.pdf). 

| Lab | Skeliton Files | Programming Language | Comments |
|-----|----------------|----------------------| ---------|
| 1   | [Lab1](Labs/Lab1) | Python            | Battery modeling |
| 2   | [Lab2](Labs/Lab2) | Python            | State of charge estimation |
| 3   | [Lab3](Labs/Lab3) | Matlab            | Battery charging |

> There is not an explicit preparation task (or preperation task sections) for the labs 1 and 2, but it is recommended to read the lab PM (try to complete the equations in the lab PM) and the Python workflow instructions (if not familiar with Python) before the lab sessions.

Here is an overview of the folder structure for the labs, please maintain the same structure when you create your own files. The folder structure is important for the Python workflow, and it is recommended to use the same folder structure for all labs. 
```bash
Labs # Folder for the labs (open this folder in VSCode, when working with the labs)
├── Lab1 # Files for Lab 1
│   ├── data # Data files for Lab 1
│   │   ├── INR18650-20R_datasheet.pdf 
│   │   ├── lowcurrent_test_data.csv # a low current test dataset used to create the OCV 
│   │   ├── test_data_FUDS_SP20_0C_80SOC.csv # Test dataset No. 3
│   │   ├── test_data_FUDS_SP20_25C_50SOC.csv # Test dataset No. 1
│   │   ├── test_data_US06_SP20_25C_80SOC.csv # Test dataset No. 2
│   │   └── training_data_DST_25C_80SOC.csv # Training data
│   └── python
│       ├── ECMModule.py # ECM module (!! do not modify this file !!)
│       └── main.py # Main file for the lab (!! Only modify the sections with "Student Code Here" !!) 
├── Lab2 # will be added later
├── Lab3 # will be added later
├── LabPM.pdf # Lab PM
├── README.md # Python workflow basics
├── requirements.txt # Python packages required for the labs
└── venv # Python virtual environment (not included in the git repository, but you create it locally)
```

## Exam

The exam is a written exam with a duration of 4 hours. The number of questions will be around 5 with a total of 40 points and the allowed aids are a ruler, calculator, and a formula sheet. The grade will be based on preliminary the following scale:
* 0-16 points:  U (Fail)
* 17-24 points: 3 (Pass)    
* 25-32 points: 4 (Good)
* 33-40 points: 5 (Excellent)

Old exams are available in the [Exams](Exams) folder.
* [exam241218](Exams/exam241218.pdf) 

## Reading Material

* [Electrochemical Engineering](https://liuonline.sharepoint.com/:b:/r/sites/Lisam_TSFS19_2025VT_59/CourseDocuments/Reading%20Material/Electrochemical_Engineering.pdf?csf=1&web=1&e=Q0dHgA) (EE), Tomas Fuller, John Harb, John Wiley & Sons, 20 mars 2018.
* [Matthew Lacey](https://lacey.se/projects) provides educational material for battery modeling among other things a lot of information about Electrochemical Impedance Spectroscopy (EIS).


## Public Battery Data
- [Battery data](https://calce.umd.edu/data) including 6 datasets from the University of Maryland. INR 18650-20R is a candidate data set for the first lab.
- [ESC model toolbox (1.2GB)](http://mocha-java.uccs.edu/BMS1/CH02/ESCtoolbox.zip) contains data sets for 6 different batteries from the University of Colorado.
